# Class ModelKitPopup

java.lang.Object
org.jmol.popup.GenericPopup
org.jmol.popup.JmolGenericPopup
org.jmol.modelkit.ModelKitPopup

All Implemented Interfaces:
  `GenericMenuInterface`

Direct Known Subclasses:
  `AwtModelKitPopup, JSModelKitPopup`

public abstract class ModelKitPopup extends JmolGenericPopup
An abstract popup class that is instantiated for a given platform and context as one of:

      -- abstract ModelKitPopup
         -- AwtModelKitPopup
         -- JSModelKitPopup

## Field Summary

Fields
Modifier and Type
Field
Description
`protected SC`
`bondRotationCheckBox`
`protected SC`
`prevBondCheckBox`

### Fields inherited from class JmolGenericPopup

`frankPopup, menuText, nFrankList, vwr`

### Fields inherited from class GenericPopup

`allowSignedFeatures, buttonGroup, currentMenuItemId, helper, htCheckbox, htMenus, isApplet, isJS, isSigned, isTainted, isWebGL, menuName, popupMenu, strMenuStructure, thisPopup, thisx, thisy, updatingForShow`

## Constructor Summary

Constructors
Constructor
Description
`ModelKitPopup()`

## Method Summary

Modifier and Type
Method
Description
`protected boolean`
`appGetBooleanProperty(String name)`
//////////////// menu execution //////////////
`protected boolean`
`appRunSpecialCheckBox(SC item, String basename, String script, boolean TF)`
`protected void`
`appUpdateForShow()`
`protected void`
`appUpdateSpecialCheckBoxValue(SC source, String actionCommand, boolean selected)`
Set the active menu based on updating a value -- usually by the user, but also during setup (ignored).
`void`
`clearLastModelSet()`
`protected void`
`exitBondRotation()`
`protected PopupResource`
`getBundle(String menu)`
///////////// menu creation and update ///////////////
`protected String`
`getScriptForCallback(SC source, String id, String script)`
Secondary processing of menu item click
`String`
`getUnknownCheckBoxScriptToRun(SC item, String name, String what, boolean TF)`
`void`
`jpiShow(int x, int y)`
`void`
`jpiUpdateComputedMenus()`
`void`
`menuClickCallback(SC source, String script)`
`void`
`menuFocusCallback(String name, String actionCommand, boolean gained)`
//// run time event-driven methods
`protected abstract void`
`menuHidePopup(SC popup)`
`String`
`setActiveMenu(String name)`
Set the active menu and request a repaint.
`protected void`
`updateAllXtalMenuOptions()`
`void`
`updateCheckBoxesForModelKit(String menuName)`
`protected void`
`updateOperatorMenu()`

### Methods inherited from class JmolGenericPopup

`appFixLabel, appRestorePopupMenu, appRunScript, initialize, jpiDispose, jpiGetMenuAsObject, jpiInitialize, showFrankMenu`

### Methods inherited from class GenericPopup

`addMenu, addMenuItem, addMenuItems, appCheckItem, appCheckSpecialMenu, appGetMenuAsString, convertToMegabytes, doMenuCheckBoxCallback, doMenuClickCallback, getEntryIcon, getImageIcon, initSwing, jpiGetMenuAsString, menuAddSeparator, menuAddSubMenu, menuCheckBoxCallback, menuCreateCheckboxItem, menuCreateItem, menuEnable, menuGetId, menuGetListPosition, menuNewSubMenu, menuRemoveAll, menuSetAutoscrolls, menuSetLabel, menuShowPopup, setText, show, updateButton, updateSignedAppletItems`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### bondRotationCheckBox

protected SC bondRotationCheckBox

### prevBondCheckBox

protected SC prevBondCheckBox

## Constructor Details

### ModelKitPopup

public ModelKitPopup()

## Method Details

### menuHidePopup

protected abstract void menuHidePopup(SC popup)

### getBundle

protected PopupResource getBundle(String menu)
///////////// menu creation and update ///////////////

Specified by:
  `getBundle` in class `JmolGenericPopup`

### jpiShow

public void jpiShow(int x, int y)

Specified by:
  `jpiShow` in interface `GenericMenuInterface`
Overrides:
  `jpiShow` in class `JmolGenericPopup`

### jpiUpdateComputedMenus

public void jpiUpdateComputedMenus()

### appUpdateForShow

protected void appUpdateForShow()

Specified by:
  `appUpdateForShow` in class `GenericPopup`

### clearLastModelSet

public void clearLastModelSet()

### updateOperatorMenu

protected void updateOperatorMenu()

### updateAllXtalMenuOptions

protected void updateAllXtalMenuOptions()

### setActiveMenu

public String setActiveMenu(String name)
Set the active menu and request a repaint.

Parameters:
  `name` -
Returns:
  activeMenu or null

### appUpdateSpecialCheckBoxValue

protected void appUpdateSpecialCheckBoxValue(SC source, String actionCommand, boolean selected)
Set the active menu based on updating a value -- usually by the user, but also during setup (ignored).

Specified by:
  `appUpdateSpecialCheckBoxValue` in class `GenericPopup`

### exitBondRotation

protected void exitBondRotation()

### appGetBooleanProperty

protected boolean appGetBooleanProperty(String name)
//////////////// menu execution //////////////

Overrides:
  `appGetBooleanProperty` in class `JmolGenericPopup`

### getUnknownCheckBoxScriptToRun

public String getUnknownCheckBoxScriptToRun(SC item, String name, String what, boolean TF)

Specified by:
  `getUnknownCheckBoxScriptToRun` in class `GenericPopup`

### menuFocusCallback

public void menuFocusCallback(String name, String actionCommand, boolean gained)
Description copied from class: `GenericPopup`
//// run time event-driven methods

Specified by:
  `menuFocusCallback` in class `GenericPopup`

### menuClickCallback

public void menuClickCallback(SC source, String script)

Overrides:
  `menuClickCallback` in class `GenericPopup`

### getScriptForCallback

protected String getScriptForCallback(SC source, String id, String script)
Secondary processing of menu item click

Specified by:
  `getScriptForCallback` in class `GenericPopup`

### appRunSpecialCheckBox

protected boolean appRunSpecialCheckBox(SC item, String basename, String script, boolean TF)

Overrides:
  `appRunSpecialCheckBox` in class `JmolGenericPopup`

### updateCheckBoxesForModelKit

public void updateCheckBoxesForModelKit(String menuName)